# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/sound/nvidia,tegra-audio-wm8753.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: NVIDIA Tegra audio complex with WM8753 CODEC

maintainers:
  - Jon Hunter <jonathanh@nvidia.com>
  - Thierry Reding <thierry.reding@gmail.com>

allOf:
  - $ref: nvidia,tegra-audio-common.yaml#

properties:
  compatible:
    items:
      - pattern: '^[a-z0-9]+,tegra-audio-wm8753(-[a-z0-9]+)+$'
      - const: nvidia,tegra-audio-wm8753

  nvidia,audio-routing:
    $ref: /schemas/types.yaml#/definitions/non-unique-string-array
    description: |
      A list of the connections between audio components.
      Each entry is a pair of strings, the first being the connection's sink,
      the second being the connection's source. Valid names for sources and
      sinks are the pins (documented in the binding document),
      and the jacks on the board.
    minItems: 2
    items:
      enum:
        # Board Connectors
        - "Headphone Jack"
        - "Mic Jack"

        # CODEC Pins
        - LOUT1
        - LOUT2
        - ROUT1
        - ROUT2
        - MONO1
        - MONO2
        - OUT3
        - OUT4
        - LINE1
        - LINE2
        - RXP
        - RXN
        - ACIN
        - ACOP
        - MIC1N
        - MIC1
        - MIC2N
        - MIC2
        - "Mic Bias"

required:
  - nvidia,i2s-controller

unevaluatedProperties: false

examples:
  - |
    sound {
        compatible = "nvidia,tegra-audio-wm8753-whistler",
                     "nvidia,tegra-audio-wm8753";
        nvidia,model = "tegra-wm8753-harmony";

        nvidia,audio-routing =
                "Headphone Jack", "LOUT1",
                "Headphone Jack", "ROUT1";

        nvidia,i2s-controller = <&i2s1>;
        nvidia,audio-codec = <&wm8753>;

        clocks = <&clk 112>, <&clk 113>, <&clk 93>;
        clock-names = "pll_a", "pll_a_out0", "mclk";
    };
